/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefSmokeSensor A device that consists of a sensor, has category saref:Sensor, performs the saref:SensingFunction and saref:EventFunction (which notifies that a certain threshold has been exceeded), and is used for the purpose of sensing a property of type saref:Smoke.
type SarefSmokeSensor interface {
	SarefSensor
	IsSarefSmokeSensor() bool // indicates base class
}

// sSarefSmokeSensor A device that consists of a sensor, has category saref:Sensor, performs the saref:SensingFunction and saref:EventFunction (which notifies that a certain threshold has been exceeded), and is used for the purpose of sensing a property of type saref:Smoke.
type sSarefSmokeSensor struct {
	propCommon
	propSarefConsistsOfBaseSarefDeviceTypeSarefSensorMultipleSarefSensor
	propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty
	propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile
	propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState
	propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower
	propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity
	propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement
	propSarefMeasuresPropertyBaseSarefPropertyTypeSarefSmokeMultipleSarefSmoke
	propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService
	propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask
	propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefEventFunctionSarefSensingFunction
	propSarefHasDescriptionBasestringTypestringSinglestring
	propSarefHasManufacturerBasestringTypestringSinglestring
	propSarefHasModelBasestringTypestringSinglestring
}

// NewSarefSmokeSensor creates a new SarefSmokeSensor
func (mod *Model) NewSarefSmokeSensor(iri string) (ret SarefSmokeSensor, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefSmokeSensor{}
	pc := propCommon{iri: iri, typ: "SarefSmokeSensor", model: mod}
	res.propCommon = pc
	mod.addSarefSmokeSensor(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefSmokeSensor) makeMaps() {
	res.sarefConsistsOf = make(map[string]SarefSensor)
	res.sarefControlsProperty = make(map[string]SarefProperty)
	res.sarefHasProfile = make(map[string]SarefProfile)
	res.sarefHasState = make(map[string]SarefState)
	res.sarefHasTypicalConsumption = make(map[string]SarefProperty)
	res.sarefIsUsedFor = make(map[string]SarefCommodity)
	res.sarefMakesMeasurement = make(map[string]SarefMeasurement)
	res.sarefMeasuresProperty = make(map[string]SarefSmoke)
	res.sarefOffers = make(map[string]SarefService)
	res.sarefAccomplishes = make(map[string]SarefTask)
	res.sarefHasFunction = make(map[string]SarefFunction)
	if v, ok := res.model.mSarefTask["https://w3id.org/saref#Safety"]; ok {
		res.AddSarefAccomplishes(v)
	}
	return
}

// addSarefSmokeSensor adds SarefSmokeSensor to model
func (mod *Model) addSarefSmokeSensor(res SarefSmokeSensor) {
	mod.mSarefSmokeSensor[res.IRI()] = res
	mod.addSarefSensor(res)
	return
}

// SarefSmokeSensor returns all resources with given prefix
func (mod *Model) SarefSmokeSensor(prefix string) (res []SarefSmokeSensor) {
	for i := range mod.mSarefSmokeSensor {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefSmokeSensor[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefSmokeSensor) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#consistsOf":
		res.propSarefConsistsOfBaseSarefDeviceTypeSarefSensorMultipleSarefSensor.removeObject(obj)
	case "https://w3id.org/saref#controlsProperty":
		res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.removeObject(obj)
	case "https://w3id.org/saref#hasProfile":
		res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.removeObject(obj)
	case "https://w3id.org/saref#hasState":
		res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.removeObject(obj)
	case "https://w3id.org/saref#hasTypicalConsumption":
		res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.removeObject(obj)
	case "https://w3id.org/saref#isUsedFor":
		res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.removeObject(obj)
	case "https://w3id.org/saref#makesMeasurement":
		res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.removeObject(obj)
	case "https://w3id.org/saref#measuresProperty":
		res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefSmokeMultipleSarefSmoke.removeObject(obj)
	case "https://w3id.org/saref#offers":
		if v, ok := obj.(SarefService); ok {
			res.DelSarefOffers(v)
		}
	case "https://w3id.org/saref#accomplishes":
		if v, ok := obj.(SarefTask); ok {
			res.DelSarefAccomplishes(v)
		}
	case "https://w3id.org/saref#hasFunction":
		res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefEventFunctionSarefSensingFunction.removeObject(obj)
	default:
	}
	return
}

// isSarefSmokeSensor indicates base class
func (res *sSarefSmokeSensor) IsSarefSmokeSensor() bool {
	return true
}

// isSarefSensor indicates base class
func (res *sSarefSmokeSensor) IsSarefSensor() bool {
	return true
}

// isSarefFunctionRelated indicates base class
func (res *sSarefSmokeSensor) IsSarefFunctionRelated() bool {
	return true
}

// isSarefDevice indicates base class
func (res *sSarefSmokeSensor) IsSarefDevice() bool {
	return true
}

// SetSarefOffers is setter of A relationship between a device and a service
func (res *sSarefSmokeSensor) SetSarefOffers(in []SarefService) (err error) {
	temp := res.sarefOffers
	res.sarefOffers = make(map[string]SarefService)
	for i := range temp {
		temp[i].DelSarefIsOfferedBy(res)
	}
	err = res.AddSarefOffers(in...)
	return
}

// AddSarefOffers adds A relationship between a device and a service
func (res *sSarefSmokeSensor) AddSarefOffers(in ...SarefService) (err error) {
	for i := range in {
		if _, ok := res.sarefOffers[in[i].IRI()]; !ok {
			res.sarefOffers[in[i].IRI()] = in[i]
			in[i].AddSarefIsOfferedBy(res)
		}
	}
	return
}

// DelSarefOffers deletes A relationship between a device and a service
func (res *sSarefSmokeSensor) DelSarefOffers(in ...SarefService) (err error) {
	for i := range in {
		if _, ok := res.sarefOffers[in[i].IRI()]; ok {
			delete(res.sarefOffers, in[i].IRI())
			in[i].DelSarefIsOfferedBy(res)
		}
	}
	return
}

// SetSarefAccomplishes is setter of A relationship between a certain entity (e.g., a device) and the task it accomplishes
func (res *sSarefSmokeSensor) SetSarefAccomplishes(in []SarefTask) (err error) {
	temp := res.sarefAccomplishes
	res.sarefAccomplishes = make(map[string]SarefTask)
	for i := range temp {
		temp[i].DelSarefIsAccomplishedBy(res)
	}
	err = res.AddSarefAccomplishes(in...)
	return
}

// AddSarefAccomplishes adds A relationship between a certain entity (e.g., a device) and the task it accomplishes
func (res *sSarefSmokeSensor) AddSarefAccomplishes(in ...SarefTask) (err error) {
	for i := range in {
		if _, ok := res.sarefAccomplishes[in[i].IRI()]; !ok {
			res.sarefAccomplishes[in[i].IRI()] = in[i]
			in[i].AddSarefIsAccomplishedBy(res)
		}
	}
	return
}

// DelSarefAccomplishes deletes A relationship between a certain entity (e.g., a device) and the task it accomplishes
func (res *sSarefSmokeSensor) DelSarefAccomplishes(in ...SarefTask) (err error) {
	for i := range in {
		if _, ok := res.sarefAccomplishes[in[i].IRI()]; ok {
			delete(res.sarefAccomplishes, in[i].IRI())
			in[i].DelSarefIsAccomplishedBy(res)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefSmokeSensor) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefSmokeSensor) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#consistsOf":
		res.propSarefConsistsOfBaseSarefDeviceTypeSarefSensorMultipleSarefSensor.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#controlsProperty":
		res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasProfile":
		res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasState":
		res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasTypicalConsumption":
		res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#isUsedFor":
		res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#makesMeasurement":
		res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#measuresProperty":
		res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefSmokeMultipleSarefSmoke.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#offers":
		if obj, ok := res.model.mSarefService[pred.Object.Term.String()]; ok {
			res.AddSarefOffers(obj)
		}
	case "https://w3id.org/saref#accomplishes":
		if obj, ok := res.model.mSarefTask[pred.Object.Term.String()]; ok {
			res.AddSarefAccomplishes(obj)
		}
	case "https://w3id.org/saref#hasFunction":
		res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefEventFunctionSarefSensingFunction.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasDescription":
		res.propSarefHasDescriptionBasestringTypestringSinglestring.init(pred.Object.Term.String())
	case "https://w3id.org/saref#hasManufacturer":
		res.propSarefHasManufacturerBasestringTypestringSinglestring.init(pred.Object.Term.String())
	case "https://w3id.org/saref#hasModel":
		res.propSarefHasModelBasestringTypestringSinglestring.init(pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefSmokeSensor) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#SmokeSensor", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefSmokeSensor) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefConsistsOfBaseSarefDeviceTypeSarefSensorMultipleSarefSensor.toGraph(node, g)
	res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.toGraph(node, g)
	res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.toGraph(node, g)
	res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.toGraph(node, g)
	res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.toGraph(node, g)
	res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.toGraph(node, g)
	res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.toGraph(node, g)
	res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefSmokeMultipleSarefSmoke.toGraph(node, g)
	res.propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService.toGraph(node, g)
	res.propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask.toGraph(node, g)
	res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefEventFunctionSarefSensingFunction.toGraph(node, g)
	res.propSarefHasDescriptionBasestringTypestringSinglestring.toGraph(node, g)
	res.propSarefHasManufacturerBasestringTypestringSinglestring.toGraph(node, g)
	res.propSarefHasModelBasestringTypestringSinglestring.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefSmokeSensor) String() (ret string) {
	ret = res.iri + " " + "SarefSmokeSensor\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefSmokeSensor) propsString() (ret string) {
	ret = ""
	ret += res.propSarefConsistsOfBaseSarefDeviceTypeSarefSensorMultipleSarefSensor.String()
	ret += res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.String()
	ret += res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.String()
	ret += res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.String()
	ret += res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.String()
	ret += res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.String()
	ret += res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.String()
	ret += res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefSmokeMultipleSarefSmoke.String()
	ret += res.propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService.String()
	ret += res.propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask.String()
	ret += res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefEventFunctionSarefSensingFunction.String()
	ret += res.propSarefHasDescriptionBasestringTypestringSinglestring.String()
	ret += res.propSarefHasManufacturerBasestringTypestringSinglestring.String()
	ret += res.propSarefHasModelBasestringTypestringSinglestring.String()
	return
}


